↓ Skip to main content
  1. Posts/

hdu 1171 Big Event in HDU (母函数,01背包)

·1075 words·3 mins
Note: This article is available in Chinese only. 本文暂无英文版本。 View original

**Time Limit: 10000/5000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 26534 Accepted Submission(s): 9332 **

Problem Description

Nowadays, we all know that Computer College is the biggest department in HDU. But, maybe you don’t know that Computer College had ever been split into Computer College and Software College in 2002. The splitting is absolutely a big event in HDU! At the same time, it is a trouble thing too. All facilities must go halves. First, all facilities are assessed, and two facilities are thought to be same if they have the same value. It is assumed that there is N (0<N<1000) kinds of facilities (different value, different kinds).

Input

Input contains multiple test cases. Each test case starts with a number N (0 < N <= 50 – the total number of different facilities). The next N lines contain an integer V (0<V<=50 –value of facility) and an integer M (0<M<=100 –corresponding number of the facilities) each. You can assume that all V are different. A test case starting with a negative integer terminates input and this test case is not to be processed.

Output

For each case, print one line containing two integers A and B which denote the value of Computer College and Software College will get respectively. A and B should be as equal as possible. At the same time, you should guarantee that A is not less than B.

Sample Input

2 10 1 20 1 3 10 1 20 2 30 1 -1

Sample Output

20 10 40 40

背包。

所有的设备不是放在第一部分,就是要放在第二部分。

那么对于第一部分,或者第二部分,每一个设备就只有放和不放两种情况。

然后感觉就是做一个容量为总数的一半的01背包

然后脑抽看到第一部分可以大于一半,觉得这么想是错的。。。

实际上并不是,因为第二部分总要比第一部分小,所以第二部分是不可能大于一半的。

所以我们对于第二部分做01背包。

代码实现
 1
 2    /* ***********************************************
 3    Author :111qqz
 4    Created Time :2016年02月22日 星期一 22时52分26秒
 5    File Name :code/hdu/1171.cpp
 6    ************************************************ */
 7
 8    #include <iostream>
 9    #include <algorithm>
10    #include <cstring>
11    #include <cstdio>
12    #include <cmath>
13
14    using namespace std;
15    const int N=3E6+5;
16    int a[N],dp[N];
17    int n,x,y;
18    int tmp;
19    int sum;
20
21    void solve(int value ,int cost)
22    {
23        for ( int i = sum/2 ; i >= cost ; i--)
24        {
25            dp [i] = max(dp[i],dp[i-cost]+value);
26        }
27
28    }
29
30    int main()
31    {
32        while (scanf("%d",&n)!=EOF)
33        {
34            if( n<0 ) break;
35            memset(dp,0,sizeof(dp));
36            memset(a,0,sizeof(a));
37            tmp = 1;
38            sum = 0;
39            for ( int i = 1 ; i <= n ; i++ )
40            {
41                scanf("%d %d",&x,&y);
42                sum = sum +x*y;
43                for ( int j =1 ; j <= y ; j++)
44                {
45                    a[tmp] = x;
46                    tmp++;
47                }
48            }
49            for ( int i = 1 ; i <= tmp ; i++)
50                solve (a[i],a[i]);
51            printf("%d %d\n",sum-dp[sum/2],dp[sum/2]);
52        }
53
54        return 0;
55    }

还有一种母函数的做法:先得到每种价值有多少种方案,然后从总价值一半向下找到第一个方案数非 0 的价值,就是答案。
#

注意。。。数组开小不一定是 re…tle,wa,re 都有可能

代码实现
 1
 2
 3    /* ***********************************************
 4    Author :111qqz
 5    Created Time :2016年02月25日 星期四 23时08分48秒
 6    File Name :code/hdu/_1171.cpp
 7    ************************************************ */
 8
 9    #include <cstdio>
10    #include <cstring>
11    #include <iostream>
12    #include <algorithm>
13    #include <vector>
14    #include <queue>
15    #include <set>
16    #include <map>
17    #include <string>
18    #include <cmath>
19    #include <cstdlib>
20    #include <ctime>
21    #define fst first
22    #define sec second
23    #define lson l,m,rt<<1
24    #define rson m+1,r,rt<<1|1
25    #define ms(a,x) memset(a,x,sizeof(a))
26    typedef long long LL;
27    #define pi pair < int ,int >
28    #define MP make_pair
29
30    using namespace std;
31    const double eps = 1E-8;
32    const int dx4[4]={1,0,0,-1};
33    const int dy4[4]={0,-1,1,0};
34    const int inf = 0x3f3f3f3f;
35    const int N=3E5+7;
36    int n;
37    int a[N],tmp[N];
38    int v[55],num[55];
39    int main()
40    {
41    	#ifndef  ONLINE_JUDGE
42    	freopen("code/in.txt","r",stdin);
43      #endif
44
45    	while (scanf("%d",&n))
46    	{
47    	    if (n<0) break;
48
49    	    for ( int i =  1 ; i <= n ; i++)
50    	    {
51    		scanf("%d %d",&v[i],&num[i]);
52    	    }
53
54    	    ms(a,0);
55    	    for ( int i = 0 ; i <= num[1]*v[1] ; i+=v[1])
56    	    {
57    		a[i] = 1;
58    	    }
59
60    	    int cur = num[1]*v[1];
61    	    for ( int i = 2 ; i <= n ; i++)
62    	    {
63    		for ( int j = 0 ; j <= cur ;  j++)
64    		{
65    		    for ( int k = 0 ; k<=num[i]*v[i] ; k +=v[i] )
66    		    {
67    			tmp[j+k] += a[j];
68    		    }
69    		}
70
71    		cur += num[i]*v[i];
72
73    		for ( int j = 0 ; j <= cur ; j++)
74    		{
75    		    a[j] = tmp[j];
76    		    tmp[j] = 0 ;
77    		}
78    	    }
79
80    	    for ( int i = cur/2 ; i >= 0 ; i--)
81    	    {
82    		if (a[i]!=0)
83    		{
84    		    printf("%d %d\n",cur-i,i);
85    		    break;
86    		}
87    	    }
88    	}
89
90      #ifndef ONLINE_JUDGE
91      fclose(stdin);
92      #endif
93        return 0;
94    }

Related

hdu 1203 I NEED A OFFER! (01背包)

·977 words·2 mins
I NEED A OFFER! # **Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 18287 Accepted Submission(s): 7320 ** Problem Description Speakless很早就想出国,现在他已经考完了所有需要的考试,准备了所有要准备的材料,于是,便需要去申请学校了。要申请国外的任何大学,你都要交纳一定的申请费用,这可是很惊人的。Speakless没有多少钱,总共只攒了n万美元。他将在m个学校中选择若干的(当然要在他的经济承受范围内)。每个学校都有不同的申请费用a(万美元),并且Speakless估计了他得到这个学校offer的可能性b。不同学校之间是否得到offer不会互相影响。“I NEED A OFFER”,他大叫一声。帮帮这个可怜的人吧,帮助他计算一下,他可以收到至少一份offer的最大概率。(如果Speakless选择了多个学校,得到任意一个学校的offer都可以)。

hdu 2546 饭卡 (01背包)

·692 words·2 mins
饭卡 # **Time Limit: 5000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 14225 Accepted Submission(s): 4945 ** Problem Description 电子科大本部食堂的饭卡有一种很诡异的设计,即在购买之前判断余额。如果购买一个商品之前,卡上的剩余金额大于或等于5元,就一定可以购买成功(即使购买后卡上余额为负),否则无法购买(即使金额足够)。所以大家都希望尽量使卡上的余额最少。 某天,食堂中有n种菜出售,每种菜可购买一次。已知每种菜的价格以及卡上的余额,问最少可使卡上的余额为多少。

hdu 5119 - Happy Matt Friends(dp解法)

·820 words·2 mins
Description Matt has N friends. They are playing a game together. Each of Matt’s friends has a magic number. In the game, Matt selects some (could be zero) of his friends. If the xor (exclusive-or) sum of the selected friends’magic numbers is no less than M , Matt wins. Matt wants to know the number of ways to win. Input The first line contains only one integer T , which indicates the number of test cases.

HDOJ 4882 Loves Codefires

·589 words·2 mins
ZCC Loves Codefires Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 988 Accepted Submission(s): 500 Problem Description Though ZCC has many Fans, ZCC himself is a crazy Fan of a coder, called “Memset137”. It was on Codefires(CF), an online competitive programming site, that ZCC knew Memset137, and immediately became his fan. But why? Because Memset137 can solve all problem in rounds, without unsuccessful submissions; his estimation of time to solve certain problem is so accurate, that he can surely get an Accepted the second he has predicted. He soon became IGM, the best title of Codefires. Besides, he is famous for his coding speed and the achievement in the field of Data Structures. After become IGM, Memset137 has a new goal: He wants his score in CF rounds to be as large as possible. What is score? In Codefires, every problem has 2 attributes, let’s call them Ki and Bi(Ki, Bi>0). if Memset137 solves the problem at Ti-th second, he gained Bi-KiTi score. It’s guaranteed Bi-KiTi is always positive during the round time. Now that Memset137 can solve every problem, in this problem, Bi is of no concern. Please write a program to calculate the minimal score he will lose.(that is, the sum of Ki*Ti).

poj 1065 Wooden Sticks

·730 words·2 mins
Wooden Sticks Time Limit: 1000MS Memory Limit: 10000K Total Submissions: 19008 Accepted: 8012 Description There is a pile of n wooden sticks. The length and weight of each stick are known in advance. The sticks are to be processed by a woodworking machine in one by one fashion. It needs some time, called setup time, for the machine to prepare processing a stick. The setup times are associated with cleaning operations and changing tools and shapes in the machine. The setup times of the woodworking machine are given as follows: (a) The setup time for the first wooden stick is 1 minute. (b) Right after processing a stick of length l and weight w , the machine will need no setup time for a stick of length l’ and weight w’ if l <= l’ and w <= w’. Otherwise, it will need 1 minute for setup. You are to find the minimum setup time to process a given pile of n wooden sticks. For example, if you have five sticks whose pairs of length and weight are ( 9 , 4 ) , ( 2 , 5 ) , ( 1 , 2 ) , ( 5 , 3 ) , and ( 4 , 1 ) , then the minimum setup time should be 2 minutes since there is a sequence of pairs ( 4 , 1 ) , ( 5 , 3 ) , ( 9 , 4 ) , ( 1 , 2 ) , ( 2 , 5 ) . Input